rem
	bbdoc: Type description
end rem

Import "TGameElement.bmx"
Import "TCoordinate.bmx"
Import "TBullet.bmx"

Incbin "gfx/turret.png"

Type TPlayer Extends TGameElement
	Global playerImg:TImage
	
	Field dir:TCoordinate

		
	Function Create:TPlayer(pos:TCoordinate)
		AutoMidHandle(true)
		Local player:TPlayer = New TPlayer
		player.pos = pos
		player.oldPos = TCoordinate.Copy(pos)
		If playerImg = Null
			playerImg = LoadImage("incbin::gfx/turret.png")
		End If
		Return player
	End Function

		
	Method Update(fixedRate:Float)
		Local mousePos:TCoordinate
		mousePos = TCoordinate.Create(MouseX(), MouseY(), 0)
		' let's rotate to always look at the mouse
		Self.oldAngle = Self.angle
		Self.angle = pos.getAngle(mousePos)
		Self.dir = Self.pos.GetDirection(mousePos)
		If MouseHit(1)
			'create a bullet
			TBullet.Create(Self.pos, TCoordinate.Copy(self.dir), TBullet.defaultspeed)
		End If
	End Method

		
	Method Render(tween:Float)
		SetRotation(self.angle)
		DrawImage(playerImg, pos.x, pos.y)
		SetRotation(0)
		rem
		If dir <> Null
			DrawText ("angle: " + dir.angle, 0, 100)
			DrawText ("x dir: " + dir.x, 0, 120)
			DrawText ("y dir: " + dir.y, 0, 140)
		EndIf
		end rem
	End Method
End Type
